player = Sprite:New()

player:setImage('player.png')
player.ox = 5
player.oy = 15
player.wx = 1
player.wy = 1
player.wz = 0
player.vx = 0
player.vy = 0
player.vz = 0
player.sollvx = 0
player.sollvy = 0
player.standing = true
player.radius = 5/64

function player:hopp()
	if self.standing then
		self.vz = 12
		self.standing = false
	end
end

function player:move(dt)
	-- geschwindigkeit anpassen
	self.vz = self.vz - 50*dt
	
	self.standing = false

	
	self.sollvx = 0
	self.sollvy = 0
	local speed = 1
	-- Ready Keyboard input and adjust target speed
	if love.keyboard.isDown("left")  then self.sollvx = self.sollvx+speed self.sollvy = self.sollvy-speed end
  if love.keyboard.isDown("right") then self.sollvx = self.sollvx-speed self.sollvy = self.sollvy+speed end
  if love.keyboard.isDown("up")    then self.sollvx = self.sollvx-speed self.sollvy = self.sollvy-speed end
  if love.keyboard.isDown("down")  then self.sollvx = self.sollvx+speed self.sollvy = self.sollvy+speed end
  
  -- Move actual speed close to target speed
  if math.abs(self.vx-self.sollvx) < 0.001 then self.vx = self.sollvx end
  if math.abs(self.vy-self.sollvy) < 0.001 then self.vy = self.sollvy end
  local acceleration = 5
  local factor = acceleration * dt / math.sqrt((self.sollvx-self.vx)^2+(self.sollvy-self.vy)^2)
  factor = math.min(factor,1)
  self.vx = self.vx+factor*(self.sollvx-self.vx)
  self.vy = self.vy+factor*(self.sollvy-self.vy)
	 	
	-- position = position+ geschwindigkeit
	local newX = self.wx + self.vx*dt
	local newY = self.wy + self.vy*dt
	local newZ = self.wz + self.vz*dt
	--self.wx = self.wx + self.vx*dt
	--self.wy = self.wy + self.vy*dt
	--self.wz = self.wz + self.vz*dt
	
	-- collision detection
	maxStep = 1/6
	-- is there any height problem??
	local nextGroundz = zFromMapAndRadius(newX,newY,self.radius)
	-- Hierweiter machen.
	
	
	-- collision to smallX ?	
	if math.floor(newX-self.radius) < math.floor(self.wx-self.radius) and
	   zFromMapAndRadius(newX,newY,self.radius) > newZ + maxStep then
	  newX = math.floor(self.wx)+self.radius+0.0001
	  self.vx = 0
	end
	
	-- collision to smallY ?
	if math.floor(newY-self.radius) < math.floor(self.wy-self.radius) and
	   zFromMapAndRadius(newX,newY,self.radius) > newZ + maxStep then
	  newY = math.floor(self.wy)+self.radius+0.0001
	  self.vy = 0
	end
	
	-- collision to largeX ?
	if math.floor(newX+self.radius) > math.floor(self.wx+self.radius) and
	   zFromMapAndRadius(newX,newY,self.radius) > newZ + maxStep then
	  newX = math.floor(self.wx)+1-self.radius-0.0001
	  self.vx = 0
	end
	
	-- collision to largeY ?
	if math.floor(newY+self.radius) > math.floor(self.wy+self.radius) and
	   zFromMapAndRadius(newX,newY,self.radius) > newZ + maxStep then
	  newY = math.floor(self.wy)+1-self.radius-0.0001
	  self.vy = 0
	end	
	
	
	-- finaly set new position
	self.wx = newX
	self.wy = newY
	self.wz = newZ
	
	--local groundz = zFromMap(player.wx,player.wy)
	local groundz = zFromMapAndRadius(player.wx,player.wy,player.radius)	
	if self.wz <= groundz then
		self.standing = true
		self.wz = groundz
		self.vz = math.max(0,self.vz)
		camwzAim = groundz
	end

end
