function love.load()
	require "game"
	require "main"
	require "menu"
	require "map"
	require "sprites"
	require "prototypes"
	require "player"


-- Grafiken laden
-- Spielmodus auf "spiel" setzen


	Spriteliste = {}
	-- table.insert(Spriteliste, Sprite:New({img = love.graphics.newImage('kachel1.png')}))
	table.insert(Spriteliste, player)
	
	shadow = Sprite:New()
	shadow.ox = 5
	shadow.oy = 3
	shadow.img = love.graphics.newImage('shadow.png')
	shadow.radius = shadow.ox/64
	function shadow:move()
	self.wx = player.wx
	self.wy = player.wy
	self.wz = zFromMapAndRadius(self.wx,self.wy,self.radius)
	end
	table.insert(Spriteliste, shadow)
	--[[--teil = Sprite:New()
	table.insert(Spriteliste, Sprite:New({x = 300}))
	table.insert(Spriteliste, Sprite:New({img = love.graphics.newImage('kachel1.png')}))
	table.insert(Spriteliste, Sprite:New())
	do
	local neu = Sprite:New()
	neu:setImage('kachel1.png')
	neu.x = 150
	table.insert(Spriteliste, neu)
	end]]
	-- Vorbereiten der Kacheln
	love.graphics.setDefaultImageFilter("nearest", "nearest")
	kacheln = love.graphics.newImage("kacheln.png")
	kachel = {}
	for i = 1,19 do
	  kachel[i] = love.graphics.newCanvas(128,113)
	  kachel[i]:setFilter('nearest','nearest')
		love.graphics.setCanvas(kachel[i])
		love.graphics.draw(kacheln,-128*(i-1),0)
	end
	wand = love.graphics.newImage("wand.png")
	love.graphics.setCanvas()
	
	love.graphics.print('Erzeuge Karte',400,300)
	love.graphics.present()
	zmap = new_zmap(20,10)
	map = zmap_to_map(zmap)
	
	mapMaxZ = 10
	love.graphics.print('Zeichne Karte',400,300)
	love.graphics.present()
	mapPicture = drawMapCanvas()
	love.graphics.print('Zeichne Streifen',400,320)
	love.graphics.present()
	Stripes = drawMapStripes()
	love.graphics.print('Zeichne Stencils',400,340)
	love.graphics.present()
	stencils = drawStencils()
	love.graphics.print('Fertig',400,360)
	love.graphics.present()
	
	camx = 0
	camy = 0
	camwx = 0
	camwy = 0
	camwz = 0
	camwzAim = 0
	modus = 'game'
	currentStencil = 2
end

function love.update(dt)
	if modus == 'menu' then
		menu.update(dt)
	elseif modus == 'game' then
		game.update(dt)
	end	
end

function love.draw()
	if modus == 'menu' then
		menu.draw()
	elseif modus == 'game' then
		game.draw()
	end	
end

function love.keypressed(key)
	if modus == 'menu' then
		menu.keypressed(key)
	elseif modus == 'game' then
		game.keypressed(key)
	end	
end




